Module javafx.base
Package javafx.beans

# Interface Observable

All Known Subinterfaces:
  `Binding<T>`, `JavaBeanProperty<T>`, `NumberBinding`, `NumberExpression`, `ObservableArray<T>`, `ObservableBooleanValue`, `ObservableDoubleValue`, `ObservableFaceArray`, `ObservableFloatArray`, `ObservableFloatValue`, `ObservableIntegerArray`, `ObservableIntegerValue`, `ObservableList<E>`, `ObservableListValue<E>`, `ObservableLongValue`, `ObservableMap<K,V>`, `ObservableMapValue<K,V>`, `ObservableNumberValue`, `ObservableObjectValue<T>`, `ObservableSet<E>`, `ObservableSetValue<E>`, `ObservableStringValue`, `ObservableValue<T>`, `Platform.Preferences`, `Property<T>`, `ReadOnlyJavaBeanProperty<T>`, `ReadOnlyProperty<T>`, `TextInputControl.Content`, `WritableListValue<E>`, `WritableMapValue<K,V>`, `WritableSetValue<E>`

All Known Implementing Classes:
  `BooleanBinding`, `BooleanExpression`, `BooleanProperty`, `BooleanPropertyBase`, `DoubleBinding`, `DoubleExpression`, `DoubleProperty`, `DoublePropertyBase`, `FilteredList`, `FloatBinding`, `FloatExpression`, `FloatProperty`, `FloatPropertyBase`, `IntegerBinding`, `IntegerExpression`, `IntegerProperty`, `IntegerPropertyBase`, `JavaBeanBooleanProperty`, `JavaBeanDoubleProperty`, `JavaBeanFloatProperty`, `JavaBeanIntegerProperty`, `JavaBeanLongProperty`, `JavaBeanObjectProperty`, `JavaBeanStringProperty`, `ListBinding`, `ListExpression`, `ListProperty`, `ListPropertyBase`, `LongBinding`, `LongExpression`, `LongProperty`, `LongPropertyBase`, `MapBinding`, `MapExpression`, `MapProperty`, `MapPropertyBase`, `ModifiableObservableListBase`, `NumberExpressionBase`, `ObjectBinding`, `ObjectExpression`, `ObjectProperty`, `ObjectPropertyBase`, `ObservableArrayBase`, `ObservableListBase`, `ObservableValueBase`, `ReadOnlyBooleanProperty`, `ReadOnlyBooleanPropertyBase`, `ReadOnlyBooleanWrapper`, `ReadOnlyDoubleProperty`, `ReadOnlyDoublePropertyBase`, `ReadOnlyDoubleWrapper`, `ReadOnlyFloatProperty`, `ReadOnlyFloatPropertyBase`, `ReadOnlyFloatWrapper`, `ReadOnlyIntegerProperty`, `ReadOnlyIntegerPropertyBase`, `ReadOnlyIntegerWrapper`, `ReadOnlyJavaBeanBooleanProperty`, `ReadOnlyJavaBeanDoubleProperty`, `ReadOnlyJavaBeanFloatProperty`, `ReadOnlyJavaBeanIntegerProperty`, `ReadOnlyJavaBeanLongProperty`, `ReadOnlyJavaBeanObjectProperty`, `ReadOnlyJavaBeanStringProperty`, `ReadOnlyListProperty`, `ReadOnlyListPropertyBase`, `ReadOnlyListWrapper`, `ReadOnlyLongProperty`, `ReadOnlyLongPropertyBase`, `ReadOnlyLongWrapper`, `ReadOnlyMapProperty`, `ReadOnlyMapPropertyBase`, `ReadOnlyMapWrapper`, `ReadOnlyObjectProperty`, `ReadOnlyObjectPropertyBase`, `ReadOnlyObjectWrapper`, `ReadOnlySetProperty`, `ReadOnlySetPropertyBase`, `ReadOnlySetWrapper`, `ReadOnlyStringProperty`, `ReadOnlyStringPropertyBase`, `ReadOnlyStringWrapper`, `SetBinding`, `SetExpression`, `SetProperty`, `SetPropertyBase`, `SimpleBooleanProperty`, `SimpleDoubleProperty`, `SimpleFloatProperty`, `SimpleIntegerProperty`, `SimpleListProperty`, `SimpleLongProperty`, `SimpleMapProperty`, `SimpleObjectProperty`, `SimpleSetProperty`, `SimpleStringProperty`, `SimpleStyleableBooleanProperty`, `SimpleStyleableDoubleProperty`, `SimpleStyleableFloatProperty`, `SimpleStyleableIntegerProperty`, `SimpleStyleableLongProperty`, `SimpleStyleableObjectProperty`, `SimpleStyleableStringProperty`, `SortedList`, `StringBinding`, `StringExpression`, `StringProperty`, `StringPropertyBase`, `StyleableBooleanProperty`, `StyleableDoubleProperty`, `StyleableFloatProperty`, `StyleableIntegerProperty`, `StyleableLongProperty`, `StyleableObjectProperty`, `StyleableStringProperty`, `TransformationList`

public interface Observable
An `Observable` is an entity that wraps content and allows to observe the content for invalidations.

An implementation of `Observable` may support lazy evaluation, which means that the content is not immediately recomputed after changes, but lazily the next time it is requested. All bindings and properties in this library support lazy evaluation.

Implementations of this class should strive to generate as few events as possible to avoid wasting too much time in event handlers. Implementations in this library mark themselves as invalid when the first invalidation event occurs. They do not generate anymore invalidation events until their value is recomputed and valid again.

Since:
  JavaFX 2.0
See Also:
  - `ObservableValue`
  - `ObservableList`
  - `ObservableMap`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addListener(InvalidationListener listener)`
  Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
  `void`
  `removeListener(InvalidationListener listener)`
  Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
  `default Subscription`
  `subscribe(Runnable invalidationSubscriber)`
  Creates a `Subscription` on this `Observable` which calls `invalidationSubscriber` whenever it becomes invalid.

- ## Method Details

  - ### addListener

    void addListener(InvalidationListener listener)
    Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

    The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

    Parameters:
      `listener` - The listener to register
    Throws:
      `NullPointerException` - if the listener is null
    See Also:
      - `removeListener(InvalidationListener)`

  - ### removeListener

    void removeListener(InvalidationListener listener)
    Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Parameters:
      `listener` - The listener to remove
    Throws:
      `NullPointerException` - if the listener is null
    See Also:
      - `addListener(InvalidationListener)`

  - ### subscribe

    default Subscription subscribe(Runnable invalidationSubscriber)
    Creates a `Subscription` on this `Observable` which calls `invalidationSubscriber` whenever it becomes invalid. The provided subscriber is akin to an `InvalidationListener` without the `Observable` parameter. If the same subscriber is subscribed more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same subscriber instance may be safely subscribed for different `Observables`.

    Also note that when subscribing on an `Observable` with a longer lifecycle than the subscriber, the subscriber must be unsubscribed when no longer needed as the subscription will otherwise keep the subscriber from being garbage collected.

    Parameters:
      `invalidationSubscriber` - a `Runnable` to call whenever this value becomes invalid, cannot be `null`
    Returns:
      a `Subscription` which can be used to cancel this subscription, never `null`
    Throws:
      `NullPointerException` - if the subscriber is `null`
    Since:
      21
    See Also:
      - `addListener(InvalidationListener)`